(module menu
	(include "japi/japi.sch")
	(main x-menu))

(define x-menu (lambda (args)
	     (when   (= (j_start) J_FALSE)
	     	     (printf "I can't connect to java-server\n")
                     (exit 0))
	     (let* ((frame (j_frame "")) 
	           (menubar (j_menubar frame)) 
	           (file (j_menu menubar "File"))
	           (options (j_menu menubar "Options"))
	           (submenu (j_menu options "Settings"))
		   (edit (j_menu menubar "Edit"))  
		   (help (j_helpmenu menubar "Help"))
		   (open (j_menuitem file "Open")) 
		   (save (j_menuitem file "Save")) 
		   (quit (j_menuitem file "Quit")) 
		   (about (j_menuitem help "About"))
		   (cut (j_menuitem edit "Cut")) 
		   (copy (j_menuitem edit "Copy")) 
		   (paste (j_menuitem edit "Paste"))
		   (enable (j_checkmenuitem submenu "Enable Settings")) 
		   (settings (j_menuitem submenu "Settings"))
		   (obj 0)
		   (inhalt (make-string 1024)))
	       
	       ;; Generate Graphical Objects 
	       
	       (j_disable save)
	       (j_setshortcut quit  #\a) ;; Ctrl-Numpad-1

	       (j_disable settings)

	       (j_show frame)

	       ;; Waiting for actions 
	       (do () ((= obj quit) (= obj frame))
		 (set! obj (j_nextaction))
		 (cond ((= obj enable)
			(cond ((= (j_getstate enable) J_FALSE)
			       (j_disable settings)
			       #t)
			      (else
			       (j_enable settings)
			       #t)))
		       ((= obj cut) (print "Cut!\n"))
		       ((= obj copy) (print "Copy\n"))
		       ((= obj paste) (print "Paste\n"))
			(j_gettext paste inhalt)
			))
	     (j_quit)
	     (exit 0))))

