;; canvas.scm

(module canvas 
	(include "japi/japi.sch")
	(main x-canvas))

(define x-canvas (lambda (args)
		   (let ((do_work 0)
			 ;; graphical Objects 
			 (frame 0) (menubar 0)
			 (file 0) (calc 0)
			 (quit 0) (start 0) (stop 0)
			 (canvas 0) (obj 0))
		     (j_setdebug 3)
		     (cond ((not (= (j_start) J_TRUE))
			    (printf "can't connect to japi-server")
			    (newline)
			    (exit 0)))
		     ;; Generate Graphical Objects 
		     (set! frame    (j_frame ""))
		     (set! menubar  (j_menubar frame))
		     (set! file     (j_menu menubar "File"))
		     (set! calc     (j_menu menubar "Calc"))
		     (set! quit     (j_menuitem file "Quit"))
		     (set! start    (j_menuitem calc "Start"))
		     (set! stop     (j_menuitem calc "Stop"))
		     (set! canvas   (j_canvas frame 256 256))
		     (j_setpos canvas 10 60)
		     (j_setnamedcolorbg canvas J_YELLOW)
		     
		     (j_show frame)
		     (j_pack frame)
		     
		     ;; Waiting for actions 
		     (do ()
			 ((= obj quit))
		       (cond ((= do_work J_TRUE)
			      (set! obj (j_getaction)))
			     (else
			      (set! obj (j_nextaction))))
		       (cond ((= obj start)
			      (set! do_work J_TRUE)
			      (j_setnamedcolorbg canvas J_YELLOW)
			      #t)
			     ((= obj stop)
			      (set! do_work J_FALSE)
			      #t))
		       (cond ((= do_work J_TRUE)
			      (j_setcolor canvas 
					  (modulo (j_random) 256)
					  (modulo (j_random) 256)
					  (modulo (j_random) 256))
			      (j_drawpixel canvas 
					  (modulo (j_random) 256)
					  (modulo (j_random) 256))
			      #t)))
		     (j_quit)
		     (exit 0))))

;; EOF
