;; Compile:  bigloo -ljapi -lwsock32 text.scm -o text

(module text
	(include "japi/japi.sch")
	(main x-text))

(define (save-file frame text)
    (let* ( (inhalt (j_gettext text (make-string 64000)))
            (fname (make-string 256))
            (filename (j_filedialog frame "File" "." fname) ) )
       (when (> (string-length filename) 1)
          (call-with-output-file filename
            (lambda(p)
               (display inhalt p)
               (close-output-port p)) )) ))

(define  (x-text args)
   (j_start)
   (let* ( ( newtext "Type your text here!")
     ;; graphical Objects 
	(frame (j_frame "A simple editor")) 
	(panel (j_panel frame)) 
	(menubar (j_menubar frame)) 
	(file (j_menu menubar "File")) 
	(new (j_menuitem file "New")) 
	(save (j_menuitem file "Save")) 
	(sep (j_seperator file))
	(quit  (j_menuitem file "Quit")) 
	(edit (j_menu menubar "Edit")) 
	(selall (j_menuitem edit "Select All")) 
	(text (j_textarea panel 25 4)) 
	(selstart 0) 
	(selend 0)
	(inhalt (make-string 65526)))

	   
      (j_setgridlayout frame 1 1)

      (j_setgridlayout panel 1 1)

      (j_setfont text J_DIALOGIN J_BOLD 18)
      (j_settext text newtext)

      (j_show frame)
      (j_pack frame)
	       
       (do ((obj (j_nextaction) (j_nextaction)))
	   ((or (= obj quit) (= obj frame)) (j_quit))
	 (cond ((= obj new) (j_settext text newtext))
	       ((= obj save)
		(save-file frame text))
	       ((= obj selall) (j_selectall text) ))  ))  )

;;EOF
